(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@ng-bootstrap/ng-bootstrap/index')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', '@ng-bootstrap/ng-bootstrap/index'], factory) :
	(factory((global['ng-bootstrap-nested-select'] = {}),global.core,global.common,global.index));
}(this, (function (exports,core,common,index) { 'use strict';

var NgBootstrapNestedSelectComponent = (function () {
    function NgBootstrapNestedSelectComponent() {
        this.items = [];
        this.default = {};
        this.selected = new core.EventEmitter();
        this.level = 1;
        this._selected = '';
    }
    /**
     * @return {?}
     */
    NgBootstrapNestedSelectComponent.prototype.ngOnInit = function () {
        this._selected = this.default;
    };
    /**
     * @param {?} event
     * @param {?} option
     * @return {?}
     */
    NgBootstrapNestedSelectComponent.prototype.selectOption = function (event, option) {
        if (option.products.length)
            event.stopPropagation();
        else {
            this._selected = option;
            this.selected.emit(this._selected);
        }
    };
    return NgBootstrapNestedSelectComponent;
}());
NgBootstrapNestedSelectComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'nested-select',
                template: "<ng-template #optionTemplate let-options=\"options\" let-i=\"index\"> <ng-template ngFor [ngForOf]=\"options\" let-opt> <div class=\"index-{{i}} option\" (click)=\"selectOption($event, opt)\" [ngClass]=\"{'dropdown-item': !opt.products.length}\">{{opt.name}}</div> <ng-template [ngIf]=\"opt.products.length\"> <ng-container [ngTemplateOutlet]=\"optionTemplate\" [ngOutletContext]=\"{options: opt.products, index: (i+1)}\"></ng-container> </ng-template> </ng-template> </ng-template> <div ngbDropdown class=\"nested-select\"> <div ngbDropdownToggle id=\"dropdownMenuButton\"> {{_selected.name}} </div> <div ngbDropdownMenu aria-labelledby=\"dropdownMenuButton\"> <ng-template ngFor [ngForOf]=\"items\" let-item let-i=\"index\"> <div class=\"parent option\" (click)=\"selectOption($event)\">{{item.name}}</div> <ng-template [ngIf]=\"item.products.length\"> <ng-container [ngTemplateOutlet]=\"optionTemplate\" [ngOutletContext]=\"{options: item.products, index: level}\"></ng-container> </ng-template> </ng-template> </div> </div> ",
                styles: [".nested-select { border: none; padding: 0; margin: 0; height: 100%; width: 100%; } .nested-select .dropdown-toggle::after { float: right; position: relative; top: 40%; } .nested-select .dropdown-menu { width: 100%; } .nested-select .dropdown-toggle { height: 100%; width: 100%; cursor: pointer; } .nested-select .option { padding: 0 .6rem; font-style: italic; } .nested-select .parent { padding: 0 .6rem; font-weight: bold; font-style: normal; } .nested-select .index-1 { padding: 0 1.2rem; } .nested-select .index-2 { padding: 0 1.8rem; } .nested-select .index-3 { padding: 0 2.4rem; } .nested-select .dropdown-item { color: #000; cursor: pointer; font-style: normal; } "]
            },] },
];
/**
 * @nocollapse
 */
NgBootstrapNestedSelectComponent.ctorParameters = function () { return []; };
NgBootstrapNestedSelectComponent.propDecorators = {
    'items': [{ type: core.Input },],
    'default': [{ type: core.Input },],
    'selected': [{ type: core.Output },],
};

var NgBootstrapNestedSelectModule = (function () {
    function NgBootstrapNestedSelectModule() {
    }
    return NgBootstrapNestedSelectModule;
}());
NgBootstrapNestedSelectModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule,
                    index.NgbModule
                ],
                declarations: [NgBootstrapNestedSelectComponent],
                exports: [NgBootstrapNestedSelectComponent]
            },] },
];
/**
 * @nocollapse
 */
NgBootstrapNestedSelectModule.ctorParameters = function () { return []; };

exports.NgBootstrapNestedSelectModule = NgBootstrapNestedSelectModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
